summaryrefslogtreecommitdiff
path: root/sh/rc-mount.sh
diff options
context:
space:
mode:
authorRoy Marples <roy@marples.name>2007-04-05 11:18:42 +0000
committerRoy Marples <roy@marples.name>2007-04-05 11:18:42 +0000
commit5af58b45146ab5253ca964738f4e45287bf963d4 (patch)
tree68d3a9a61fa55dd7fe273db776c375f797edaa5b /sh/rc-mount.sh
downloadopenrc-5af58b45146ab5253ca964738f4e45287bf963d4.tar.gz
openrc-5af58b45146ab5253ca964738f4e45287bf963d4.tar.bz2
openrc-5af58b45146ab5253ca964738f4e45287bf963d4.tar.xz
Rewrite the core parts in C. We now provide librc so other programs can
query runlevels, services and state without using bash. We also provide libeinfo so other programs can easily use our informational functions. As such, we have dropped the requirement of using bash as the init script shell. We now use /bin/sh and have strived to make the scripts as portable as possible. Shells that work are bash and dash. busybox works provided you disable s-s-d. If you have WIPE_TMP set to yes in conf.d/bootmisc you should disable find too. zsh and ksh do not work at this time. Networking support is currently being re-vamped also as it was heavily bash array based. As such, a new config format is available like so config_eth0="1.2.3.4/24 5.6.7.8/16" or like so config_eth0="'1.2.3.4 netmask 255.255.255.0' '5.6.7.8 netmask 255.255.0.0'" We will still support the old bash array format provided that /bin/sh IS a link it bash. ChangeLog for baselayout-1 can be found in our SVN repo.
Diffstat (limited to 'sh/rc-mount.sh')
-rw-r--r--sh/rc-mount.sh70
1 files changed, 70 insertions, 0 deletions
diff --git a/sh/rc-mount.sh b/sh/rc-mount.sh
new file mode 100644
index 0000000..67ea203
--- /dev/null
+++ b/sh/rc-mount.sh
@@ -0,0 +1,70 @@
+# Copyright 2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+# bool do_unmount(char *cmd, char *no_unmounts, char *nodes, char *fslist)
+# Handy function to handle all our unmounting needs
+# find-mount is a C program to actually find our mounts on our supported OS's
+do_unmount() {
+ local cmd="$1" retval=0 retry=
+ local f_opts="-m -c" f_kill="-s " mnt=
+ if [ "${RC_UNAME}" = "Linux" ] ; then
+ f_opts="-c"
+ f_kill="-"
+ fi
+
+ local mnts="$(mountinfo ${2:+--skip-regex} $2 ${3:+--node-regex} $3 ${4:+--fstype-regex} $4 --reverse \
+ | sed -e "s/'/'\\\\''/g" -e "s/^/'/g" -e "s/$/'/g")"
+ eval set -- ${mnts}
+ for mnt in "$@" ; do
+ case "${cmd}" in
+ umount*)
+ # If we're using the mount (probably /usr) then don't unmount us
+ local pids="$(fuser ${f_opts} "${mnt}" 2>/dev/null)"
+ case " ${pids} " in
+ *" $$ "*)
+ ewarn "We are using ${mnt}, not unmounting"
+ continue
+ ;;
+ esac
+ ebegin "Unmounting ${mnt}"
+ ;;
+ *)
+ ebegin "Remounting ${mnt}"
+ ;;
+ esac
+
+ retry=3
+ while ! ${cmd} "${mnt}" 2>/dev/null ; do
+ # Don't kill if it's us (/ and possibly /usr)
+ local pids="$(fuser ${f_opts} "${mnt}" 2>/dev/null)"
+ case " ${pids} " in
+ *" $$ "*) retry=0 ;;
+ " ") eend 1 "in use but fuser finds nothing"; retry=0 ;;
+ *)
+ local sig="KILL"
+ [ ${retry} -gt 0 ] && sig="TERM"
+ fuser ${f_kill}${sig} -k ${f_opts} "${mnt}" \
+ >/dev/null 2>/dev/null
+ sleep 1
+ retry=$((${retry} - 1))
+ ;;
+ esac
+
+ # OK, try forcing things
+ if [ ${retry} -le 0 ] ; then
+ ${cmd} -f "${mnt}" || retry=-999
+ retry=-999
+ break
+ fi
+ done
+ if [ ${retry} -eq -999 ] ; then
+ eend 1
+ retval=1
+ else
+ eend 0
+ fi
+ done
+ return ${retval}
+}
+
+# vim: set ts=4 :